/*******************************************************************************
 * FoxWeapon_DetonatorBase generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxWeapon_DetonatorBase extends FoxWeapon_MeleeBase
    config(Knife)
    hidecategories(Navigation);

var export editinline SkeletalMeshComponent DetonatorMesh;
var const name DetonatorSocketName;
var(Anim) private AnimNodeSlot DetonatorCustomAnimNode;
var transient bool bInDetonationMode;
var const name DetonatorFireMode;
var const class<FoxWeaponAttachment> DetonatorAttachement;
var(Animation) private array<AnimSet> MDetonatorAnimSets;
var(Animation) private array<AnimSet> FDetonatorAnimSets;

simulated event AttachWeaponTo(SkeletalMeshComponent MeshCpnt, optional name SocketName)
{
    // End:0x115
    if((Instigator.IsLocallyControlled() || Instigator.IsBeingFPSpectatedByLocalController()) && Instigator.IsHumanControlled())
    {
        AttachComponent(DetonatorMesh);
        DetonatorMesh.SetShadowParent(MeshCpnt);
        DetonatorMesh.SetLightEnvironment(MeshCpnt.LightEnvironment);
        MeshCpnt.AttachComponentToSocket(DetonatorMesh, DetonatorSocketName);
    }
    super(FoxWeapon).AttachWeaponTo(MeshCpnt, SocketName);
    //return;    
}

simulated function UpdateFirstPersonFOV(optional float NewFOV)
{
    NewFOV = -1.0;
    // End:0x2D
    if(NewFOV < float(0))
    {
        NewFOV = FirstPersonFOV;
    }
    // End:0x76
    if(FoxFirstPersonSkeletalMeshComponent(DetonatorMesh) != none)
    {
        FoxFirstPersonSkeletalMeshComponent(DetonatorMesh).SetFOV(NewFOV);
    }
    super(FoxWeapon_GrenadeBase).UpdateFirstPersonFOV(NewFOV);
    // End:0xB7
    if(Instigator != none)
    {
        Instigator.UpdateAnimSetList();
    }
    //return;    
}

simulated function ToggleHRVEffects(bool bEnabled)
{
    local int I;
    local MaterialInstanceConstant HRVMIC;

    HRVMIC = FoxPawn(Instigator).GetHRVMaterial();
    // End:0xB9
    if(bEnabled)
    {
        I = 0;
        J0x4A:
        // End:0xB6 [Loop If]
        if(I < DetonatorMesh.GetNumElements())
        {
            DetonatorMesh.SetMaterial(I, HRVMIC);
            ++ I;
            // [Loop Continue]
            goto J0x4A;
        }
    }
    // End:0x148
    else
    {
        I = 0;
        J0xC4:
        // End:0x128 [Loop If]
        if(I < DetonatorMesh.GetNumElements())
        {
            DetonatorMesh.SetMaterial(I, none);
            ++ I;
            // [Loop Continue]
            goto J0xC4;
        }
        DetonatorMesh.SetHidden(false);
    }
    super(FoxWeapon).ToggleHRVEffects(bEnabled);
    //return;    
}

simulated function SetModsVisible(const bool bShowFP, const bool bShowTP)
{
    // End:0x5C
    if((Instigator != none) && Instigator.IsLocallyControlled())
    {
        DetonatorMesh.SetHidden(bShowTP);
    }
    super(FoxWeapon_GrenadeBase).SetModsVisible(bShowFP, bShowTP);
    //return;    
}

simulated function ToggleDetonationMode(bool bEnable)
{
    // End:0x324
    if(bInDetonationMode != bEnable)
    {
        bInDetonationMode = bEnable;
        // End:0x5C
        if(Instigator != none)
        {
            Instigator.UpdateAnimSetList();
        }
        // End:0x1C7
        if(bEnable)
        {
            FiringStatesArray[0] = DetonatorFireMode;
            WeaponAttachmentClass = DetonatorAttachement;
            // End:0x1C4
            if((WorldInfo.IsServer() || WorldInfo.NetMode == NM_Standalone) && FoxPawn(Instigator).AttachClass_RightHand != DetonatorAttachement)
            {
                FoxPawn(Instigator).DetachSlot(WeaponSlot);
                FoxPawn(Instigator).SetSlotAttachment(WeaponSlot, WeaponAttachmentClass);
                Instigator.SetNetUpdateTime(WorldInfo.TimeSeconds - 1.0);
            }
        }
        // End:0x324
        else
        {
            FiringStatesArray[0] = default.FiringStatesArray[0];
            WeaponAttachmentClass = default.WeaponAttachmentClass;
            // End:0x324
            if((WorldInfo.IsServer() || WorldInfo.NetMode == NM_Standalone) && FoxPawn(Instigator).AttachClass_RightHand != WeaponAttachmentClass)
            {
                FoxPawn(Instigator).DetachSlot(WeaponSlot);
                FoxPawn(Instigator).SetSlotAttachment(WeaponSlot, WeaponAttachmentClass);
                Instigator.SetNetUpdateTime(WorldInfo.TimeSeconds - 1.0);
            }
        }
    }
    //return;    
}

simulated function FoxProjectile_GrenadeBase ThrowGrenade()
{
    ToggleDetonationMode(true);
    return super(FoxWeapon_GrenadeBase).ThrowGrenade();
    //return ReturnValue;    
}

simulated function AppendAnimSets(const bool bIsFemale, out array<AnimSet> OutAnimSets)
{
    local array<AnimSet> AnimsToAdd;
    local int I;

    super(FoxWeapon).AppendAnimSets(bIsFemale, OutAnimSets);
    // End:0xA1
    if(bInDetonationMode)
    {
        AnimsToAdd = GetDetonatorAnimSets(bIsFemale);
        I = 0;
        J0x53:
        // End:0xA1 [Loop If]
        if(I < AnimsToAdd.Length)
        {
            OutAnimSets[OutAnimSets.Length] = AnimsToAdd[I];
            ++ I;
            // [Loop Continue]
            goto J0x53;
        }
    }
    //return;    
}

private final simulated function array<AnimSet> GetDetonatorAnimSets(const bool bIsFemale)
{
    return ((bIsFemale) ? FDetonatorAnimSets : MDetonatorAnimSets);
    //return ReturnValue;    
}

simulated function bool ShouldAutoSwitchWhenOutOfAmmo()
{
    // End:0x0F
    if(bInDetonationMode)
    {
        return false;
    }
    return super(FoxWeapon).ShouldAutoSwitchWhenOutOfAmmo();
    //return ReturnValue;    
}

simulated function bool CanMelee()
{
    return super(FoxWeapon).CanMelee() && HasAmmo(0);
    //return ReturnValue;    
}

function NotifyPickup(FoxProjectile_GrenadeBase ThrownProjectile)
{
    ProjectileArray.RemoveItem(ThrownProjectile);
    ToggleDetonationMode(false);
    ClientNotifyPickup();
    //return;    
}

reliable client simulated function ClientNotifyPickup()
{
    ToggleDetonationMode(false);
    // End:0x25
    if(!HasAnyAmmo())
    {
        AddAmmo(1);
    }
    PlayPickupAnimation();
    //return;    
}

simulated function PlayPickupAnimation()
{
    local float PickupAnimationLength;
    local FoxPawn FP;

    FP = FoxPawn(Instigator);
    // End:0xCD
    if((FP != none) && FP.IsLocallyControlled() || FP.IsBeingFPSpectatedByLocalController())
    {
        PickupAnimationLength = PlayWeaponSet(AN_ReequipGrenade, 1.0);
        SetTimer(PickupAnimationLength, false, 'PlayPickupFinished');
        SetTimer(PickupAnimationLength / 2.0, false, 'ShowMesh');
    }
    //return;    
}

simulated function ShowMesh()
{
    Mesh.SetHidden(false);
    //return;    
}

simulated function PlayPickupFinished()
{
    StopWeaponSet(AN_ReequipGrenade);
    //return;    
}

simulated state DetonatingProjectile
{
    simulated function BeginState(name PreviousStateName)
    {
        local int I;
        local float AnimTime;

        SetupSimulatedState();
        IncrementFlashCount();
        // End:0xAD
        if(Role == ROLE_Authority)
        {
            I = 0;
            J0x33:
            // End:0xAD [Loop If]
            if(I < ProjectileArray.Length)
            {
                // End:0x9F
                if(FoxProjectile_GrenadeBase(ProjectileArray[I]) != none)
                {
                    FoxProjectile_GrenadeBase(ProjectileArray[I]).DoExplosion();
                }
                ++ I;
                // [Loop Continue]
                goto J0x33;
            }
        }
        StartFiringSound(0);
        AnimTime = PlayWeaponSet(AN_NormalFire, 1.0, false, true);
        SetTimer(AnimTime, false, 'DetonateFinished');
        //return;        
    }

    simulated function DetonateFinished()
    {
        StopWeaponSet(AN_NormalFire);
        ToggleDetonationMode(false);
        GotoState('Active');
        //return;        
    }
    stop;    
}

simulated state ThrowingGrenade
{
    simulated function ReleaseCookFinished()
    {
        bQuickThrow = false;
        StopWeaponSet(AN_Release);
        GotoState('Active');
        //return;        
    }
    stop;    
}

simulated state Active
{
    simulated function BeginFire(byte FireModeNum)
    {
        // End:0x22A
        if(!bDeleteMe && Instigator != none)
        {
            // End:0xC7
            if((Instigator.IsLocallyControlled() || Instigator.IsBeingFPSpectatedByLocalController()) && Instigator.IsHumanControlled())
            {
                FoxPawn(Instigator).LocalPawnDialog("Attack", 2, GetWeaponDialogName());
            }
            global.BeginFire(FireModeNum);
            // End:0x22A
            if(PendingFire(FireModeNum))
            {
                // End:0x102
                if(IsRecharging())
                {
                }
                // End:0x22A
                else
                {
                    // End:0x148
                    if((HasAmmo(FireModeNum)) || bInDetonationMode)
                    {
                        BeginRecharge();
                        SendToFiringState(FireModeNum);
                    }
                    // End:0x22A
                    else
                    {
                        // End:0x22A
                        if(FireModeNum == 0)
                        {
                            // End:0x213
                            if(!HasAnyAmmo())
                            {
                                PlayWeaponSound(FireNoAmmoSound, 0.0);
                                // End:0x1F9
                                if(Instigator.IsLocallyControlled())
                                {
                                    FoxPC(Instigator.Controller).MyFoxInput.bHoldingFiringButton = false;
                                }
                                // End:0x210
                                if(ShouldAutoSwitchWhenOutOfAmmo())
                                {
                                    LastUsedWeapon();
                                }
                            }
                            // End:0x22A
                            else
                            {
                                // End:0x22A
                                if(ShouldAutoReload())
                                {
                                    StartReload();
                                }
                            }
                        }
                    }
                }
            }
        }
        //return;        
    }
    stop;    
}

simulated state WeaponEquipping
{
    simulated function BeginState(name PreviousStateName)
    {
        DetonatorMesh.SetHidden(false);
        super.BeginState(PreviousStateName);
        //return;        
    }
    stop;    
}

simulated state Inactive
{
    simulated function BeginState(name PreviousStateName)
    {
        DetonatorMesh.SetHidden(true);
        super.BeginState(PreviousStateName);
        //return;        
    }

    simulated function EndState(name NextStateName)
    {
        DetonatorMesh.SetHidden(false);
        super(FoxWeapon).EndState(NextStateName);
        //return;        
    }

    simulated function bool HasAnyAmmo()
    {
        // End:0x0F
        if(bInDetonationMode)
        {
            return true;
        }
        return global.HasAnyAmmo();
        //return ReturnValue;        
    }
    stop;    
}

defaultproperties
{
    begin object name=DetonatorMesh0 class=FoxFirstPersonSkeletalMeshComponent
        ReplacementPrimitive=none
    object end
    // Reference: FoxFirstPersonSkeletalMeshComponent'Default__FoxWeapon_DetonatorBase.DetonatorMesh0'
    DetonatorMesh=DetonatorMesh0
    DetonatorSocketName=S_Knife
    DetonatorFireMode=DetonatingProjectile
    AN_ReequipGrenade=(TP_Anim=(AnimName=(None,None,Pickup_A)),FP_Anim=Pickup_A)
    begin object name=GearFXParticleSystemComponent0 class=FoxFirstPersonParticleSystemComponent
        ReplacementPrimitive=none
    object end
    // Reference: FoxFirstPersonParticleSystemComponent'Default__FoxWeapon_DetonatorBase.GearFXParticleSystemComponent0'
    GearFXComponent=GearFXParticleSystemComponent0
    FireFeedbackWaveform=ForceFeedbackWaveform'Default__FoxWeapon_DetonatorBase.ForceFeedbackWaveformFire'
    TightAimCameraShake=CameraShake'Default__FoxWeapon_DetonatorBase.Shake0'
    NormalCameraShake=CameraShake'Default__FoxWeapon_DetonatorBase.Shake1'
    MuzzleFlashLight=PointLightComponent'Default__FoxWeapon_DetonatorBase.LightComponent0'
    begin object name=LensComp class=LensFlareComponent
        NextTraceTime=-0.7336040
        ReplacementPrimitive=none
    object end
    // Reference: LensFlareComponent'Default__FoxWeapon_DetonatorBase.LensComp'
    MuzzleLensFlare=LensComp
    begin object name=WeaponMesh class=FoxFirstPersonSkeletalMeshComponent
        ReplacementPrimitive=none
    object end
    // Reference: FoxFirstPersonSkeletalMeshComponent'Default__FoxWeapon_DetonatorBase.WeaponMesh'
    Mesh=WeaponMesh
}